/* ***********************************************************
 * This file was automatically generated on 2019-09-27.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

/**
 * Detects presence of magnetic field
 */
public class BrickletHallEffect extends Device {
	public final static int DEVICE_IDENTIFIER = 240;
	public final static String DEVICE_DISPLAY_NAME = "Hall Effect Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "halleffect", DEVICE_IDENTIFIER, BrickletHallEffect.class);

	public final static byte FUNCTION_GET_VALUE = (byte)1;
	public final static byte FUNCTION_GET_EDGE_COUNT = (byte)2;
	public final static byte FUNCTION_SET_EDGE_COUNT_CONFIG = (byte)3;
	public final static byte FUNCTION_GET_EDGE_COUNT_CONFIG = (byte)4;
	public final static byte FUNCTION_SET_EDGE_INTERRUPT = (byte)5;
	public final static byte FUNCTION_GET_EDGE_INTERRUPT = (byte)6;
	public final static byte FUNCTION_SET_EDGE_COUNT_CALLBACK_PERIOD = (byte)7;
	public final static byte FUNCTION_GET_EDGE_COUNT_CALLBACK_PERIOD = (byte)8;
	public final static byte FUNCTION_EDGE_INTERRUPT = (byte)9;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_EDGE_COUNT = 10;

	public final static short EDGE_TYPE_RISING = (short)0;
	public final static short EDGE_TYPE_FALLING = (short)1;
	public final static short EDGE_TYPE_BOTH = (short)2;

	private List<EdgeCountListener> listenerEdgeCount = new CopyOnWriteArrayList<EdgeCountListener>();

	public class EdgeCountConfig {
		public short edgeType;
		public short debounce;

		public String toString() {
			return "[" + "edgeType = " + edgeType + ", " + "debounce = " + debounce + "]";
		}
	}

	public class EdgeInterrupt {
		public long count;
		public boolean value;

		public String toString() {
			return "[" + "count = " + count + ", " + "value = " + value + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletHallEffect#setEdgeCountCallbackPeriod(long)}. The parameters are the
	 * current count and the current value (see {@link BrickletHallEffect#getValue()} and
	 * {@link BrickletHallEffect#getEdgeCount(boolean)}).
	 * 
	 * The {@link BrickletHallEffect.EdgeCountListener} listener is only triggered if the count or value changed
	 * since the last triggering.
	 */
	public interface EdgeCountListener extends DeviceListener {
		public void edgeCount(long count, boolean value);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletHallEffect(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_EDGE_COUNT_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_EDGE_INTERRUPT)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_INTERRUPT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_EDGE_COUNT_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_EDGE_INTERRUPT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_EDGE_COUNT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long count = IPConnection.unsignedInt(bb.getInt());
				boolean value = (bb.get()) != 0;

				for (EdgeCountListener listener: listenerEdgeCount) {
					listener.edgeCount(count, value);
				}
			}
		};
	}

	/**
	 * Returns *true* if a magnetic field of 35 Gauss (3.5mT) or greater is detected.
	 */
	public boolean getValue() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VALUE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean value = (bb.get()) != 0;

		return value;
	}

	/**
	 * Returns the current value of the edge counter. You can configure
	 * edge type (rising, falling, both) that is counted with
	 * {@link BrickletHallEffect#setEdgeCountConfig(short, short)}.
	 * 
	 * If you set the reset counter to *true*, the count is set back to 0
	 * directly after it is read.
	 */
	public long getEdgeCount(boolean resetCounter) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_EDGE_COUNT, this);

		bb.put((byte)(resetCounter ? 1 : 0));

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long count = IPConnection.unsignedInt(bb.getInt());

		return count;
	}

	/**
	 * The edge type parameter configures if rising edges, falling edges or
	 * both are counted. Possible edge types are:
	 * 
	 * * 0 = rising (default)
	 * * 1 = falling
	 * * 2 = both
	 * 
	 * A magnetic field of 35 Gauss (3.5mT) or greater causes a falling edge and a
	 * magnetic field of 25 Gauss (2.5mT) or smaller causes a rising edge.
	 * 
	 * If a magnet comes near the Bricklet the signal goes low (falling edge), if
	 * a magnet is removed from the vicinity the signal goes high (rising edge).
	 * 
	 * The debounce time is given in ms.
	 * 
	 * Configuring an edge counter resets its value to 0.
	 * 
	 * If you don't know what any of this means, just leave it at default. The
	 * default configuration is very likely OK for you.
	 * 
	 * Default values: 0 (edge type) and 100ms (debounce time)
	 */
	public void setEdgeCountConfig(short edgeType, short debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_EDGE_COUNT_CONFIG, this);

		bb.put((byte)edgeType);
		bb.put((byte)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the edge type and debounce time as set by {@link BrickletHallEffect#setEdgeCountConfig(short, short)}.
	 */
	public EdgeCountConfig getEdgeCountConfig() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_EDGE_COUNT_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		EdgeCountConfig obj = new EdgeCountConfig();
		obj.edgeType = IPConnection.unsignedByte(bb.get());
		obj.debounce = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Sets the number of edges until an interrupt is invoked.
	 * 
	 * If *edges* is set to n, an interrupt is invoked for every n-th detected edge.
	 * 
	 * If *edges* is set to 0, the interrupt is disabled.
	 * 
	 * Default value is 0.
	 */
	public void setEdgeInterrupt(long edges) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_EDGE_INTERRUPT, this);

		bb.putInt((int)edges);

		sendRequest(bb.array());
	}

	/**
	 * Returns the edges as set by {@link BrickletHallEffect#setEdgeInterrupt(long)}.
	 */
	public long getEdgeInterrupt() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_EDGE_INTERRUPT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long edges = IPConnection.unsignedInt(bb.getInt());

		return edges;
	}

	/**
	 * Sets the period in ms with which the {@link BrickletHallEffect.EdgeCountListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletHallEffect.EdgeCountListener} listener is only triggered if the edge count has changed
	 * since the last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setEdgeCountCallbackPeriod(long period) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_EDGE_COUNT_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletHallEffect#setEdgeCountCallbackPeriod(long)}.
	 */
	public long getEdgeCountCallbackPeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_EDGE_COUNT_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * This listener is triggered every n-th count, as configured with
	 * {@link BrickletHallEffect#setEdgeInterrupt(long)}. The parameters are the
	 * current count and the current value (see {@link BrickletHallEffect#getValue()} and
	 * {@link BrickletHallEffect#getEdgeCount(boolean)}).
	 */
	public EdgeInterrupt edgeInterrupt() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_EDGE_INTERRUPT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		EdgeInterrupt obj = new EdgeInterrupt();
		obj.count = IPConnection.unsignedInt(bb.getInt());
		obj.value = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a EdgeCount listener.
	 */
	public void addEdgeCountListener(EdgeCountListener listener) {
		listenerEdgeCount.add(listener);
	}

	/**
	 * Removes a EdgeCount listener.
	 */
	public void removeEdgeCountListener(EdgeCountListener listener) {
		listenerEdgeCount.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletHallEffect.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletHallEffect.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletHallEffectConfig cfg = (BrickletHallEffectConfig) config.as(BrickletHallEffectConfig.class);
        this.addEdgeCountListener((count, value) -> {if(true) {updateStateFn.accept("HallEffectEdgeCount", transformHallEffectEdgeCountCallback0(count, value, cfg));}});
        
		{
		BrickletHallEffectEdgeCountConfig channelCfg = getChannelConfigFn.apply("HallEffectEdgeCount").as(BrickletHallEffectEdgeCountConfig.class);
		this.setEdgeCountConfig(cfg.edgeType.shortValue(), cfg.debounce.shortValue());
		            this.setEdgeInterrupt(channelCfg.refreshCount);
		}
		{
		BrickletHallEffectMagneticFieldDetectedConfig channelCfg = getChannelConfigFn.apply("HallEffectMagneticFieldDetected").as(BrickletHallEffectMagneticFieldDetectedConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletHallEffectConfig cfg = (BrickletHallEffectConfig) config.as(BrickletHallEffectConfig.class);
        this.listenerEdgeCount.clear();
        
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletHallEffectConfig cfg = (BrickletHallEffectConfig) config.as(BrickletHallEffectConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("HallEffectEdgeCount");
		result.add("HallEffectMagneticFieldDetected");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "HallEffectEdgeCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "HallEffectEdgeCount"), "Edge Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:HallEffectEdgeCount")).withDescription("The current value of the edge counter.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "HallEffectMagneticFieldDetected":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "HallEffectMagneticFieldDetected"), "Magnetic Field Detected", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:HallEffectMagneticFieldDetected")).withDescription("Enabled if a magnetic field of 35 Gauss (3.5mT) or greater is detected.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Hall Effect Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Detects presence of magnetic field").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("HallEffectEdgeCount", new ChannelTypeUID("tinkerforge", "HallEffectEdgeCount")).withLabel("Edge Count").build(), new ChannelDefinitionBuilder("HallEffectMagneticFieldDetected", new ChannelTypeUID("tinkerforge", "HallEffectMagneticFieldDetected")).withLabel("Magnetic Field Detected").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:halleffect":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("edgeType", Type.INTEGER).withDefault("0").withDescription("The edge type parameter configures if rising edges, falling edges or both are counted.").withLabel("Edge Type").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Rising"), new ParameterOption("1", "Falling"), new ParameterOption("2", "Both"))).build(), ConfigDescriptionParameterBuilder.create("debounce", Type.INTEGER).withDefault("100").withDescription("The debounce time in ms.").withLabel("Debounce Time").build(), ConfigDescriptionParameterBuilder.create("resetOnRead", Type.BOOLEAN).withDefault("false").withDescription("Enabling this will reset the edge counter after OpenHAB reads its value. Use this if you want relative edge counts per update.").withLabel("Reset Edge Count On Update").build()), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:HallEffectEdgeCount":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("refreshCount", Type.INTEGER).withDefault("1").withLabel("Refresh Value Every N-th Edge.").build()));
            case "channel-type:tinkerforge:HallEffectMagneticFieldDetected":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletHallEffectConfig cfg = (BrickletHallEffectConfig) config.as(BrickletHallEffectConfig.class);
        switch(value) {
            case "HallEffectEdgeCount": {
                   BrickletHallEffectEdgeCountConfig channelCfg = channelConfig.as(BrickletHallEffectEdgeCountConfig.class);
                   updateStateFn.accept(value, transformHallEffectEdgeCountGetter0(this.getEdgeCount(cfg.resetOnRead), cfg));
                   return;
               }
            case "HallEffectMagneticFieldDetected": {
                   BrickletHallEffectMagneticFieldDetectedConfig channelCfg = channelConfig.as(BrickletHallEffectMagneticFieldDetectedConfig.class);
                   updateStateFn.accept(value, transformHallEffectMagneticFieldDetectedGetter0(this.getValue(), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletHallEffectConfig cfg = (BrickletHallEffectConfig) config.as(BrickletHallEffectConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformHallEffectEdgeCountCallback0(long count, boolean value, BrickletHallEffectConfig cfg) {
        return new QuantityType<>(count, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformHallEffectEdgeCountGetter0(long value, BrickletHallEffectConfig cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformHallEffectMagneticFieldDetectedGetter0(boolean value, BrickletHallEffectConfig cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
}
