/* ***********************************************************
 * This file was automatically generated on 2019-09-27.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * 16-channel digital input/output
 */
public class BrickletIO16V2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2114;
	public final static String DEVICE_DISPLAY_NAME = "IO-16 Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "io16v2", DEVICE_IDENTIFIER, BrickletIO16V2.class);

	public final static byte FUNCTION_SET_VALUE = (byte)1;
	public final static byte FUNCTION_GET_VALUE = (byte)2;
	public final static byte FUNCTION_SET_SELECTED_VALUE = (byte)3;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)4;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)5;
	public final static byte FUNCTION_SET_INPUT_VALUE_CALLBACK_CONFIGURATION = (byte)6;
	public final static byte FUNCTION_GET_INPUT_VALUE_CALLBACK_CONFIGURATION = (byte)7;
	public final static byte FUNCTION_SET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION = (byte)8;
	public final static byte FUNCTION_GET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION = (byte)9;
	public final static byte FUNCTION_SET_MONOFLOP = (byte)10;
	public final static byte FUNCTION_GET_MONOFLOP = (byte)11;
	public final static byte FUNCTION_GET_EDGE_COUNT = (byte)12;
	public final static byte FUNCTION_SET_EDGE_COUNT_CONFIGURATION = (byte)13;
	public final static byte FUNCTION_GET_EDGE_COUNT_CONFIGURATION = (byte)14;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_INPUT_VALUE = 15;
	private final static int CALLBACK_ALL_INPUT_VALUE = 16;
	private final static int CALLBACK_MONOFLOP_DONE = 17;

	public final static char DIRECTION_IN = 'i';
	public final static char DIRECTION_OUT = 'o';
	public final static int EDGE_TYPE_RISING = 0;
	public final static int EDGE_TYPE_FALLING = 1;
	public final static int EDGE_TYPE_BOTH = 2;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<InputValueListener> listenerInputValue = new CopyOnWriteArrayList<InputValueListener>();
	private List<AllInputValueListener> listenerAllInputValue = new CopyOnWriteArrayList<AllInputValueListener>();
	private List<MonoflopDoneListener> listenerMonoflopDone = new CopyOnWriteArrayList<MonoflopDoneListener>();

	public class Configuration {
		public char direction;
		public boolean value;

		public String toString() {
			return "[" + "direction = " + direction + ", " + "value = " + value + "]";
		}
	}

	public class InputValueCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class AllInputValueCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class Monoflop {
		public boolean value;
		public long time;
		public long timeRemaining;

		public String toString() {
			return "[" + "value = " + value + ", " + "time = " + time + ", " + "timeRemaining = " + timeRemaining + "]";
		}
	}

	public class EdgeCountConfiguration {
		public int edgeType;
		public int debounce;

		public String toString() {
			return "[" + "edgeType = " + edgeType + ", " + "debounce = " + debounce + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletIO16V2#setInputValueCallbackConfiguration(int, long, boolean)}.
	 * 
	 * The parameters are the channel, a value-changed indicator and the actual value
	 * for the channel. The `changed` parameter is true if the value has changed since
	 * the last listener.
	 */
	public interface InputValueListener extends DeviceListener {
		public void inputValue(int channel, boolean changed, boolean value);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletIO16V2#setAllInputValueCallbackConfiguration(long, boolean)}.
	 * 
	 * The parameters are the same as {@link BrickletIO16V2#getValue()}. Additional the
	 * `changed` parameter is true if the value has changed since
	 * the last listener.
	 */
	public interface AllInputValueListener extends DeviceListener {
		public void allInputValue(boolean[] changed, boolean[] value);
	}

	/**
	 * This listener is triggered whenever a monoflop timer reaches 0. The
	 * parameters contain the channel and the current value of the channel
	 * (the value after the monoflop).
	 */
	public interface MonoflopDoneListener extends DeviceListener {
		public void monoflopDone(int channel, boolean value);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIO16V2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SELECTED_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_INPUT_VALUE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_INPUT_VALUE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_EDGE_COUNT_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_INPUT_VALUE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int channel = IPConnection.unsignedByte(bb.get());
				boolean changed = (bb.get()) != 0;
				boolean value = (bb.get()) != 0;

				for (InputValueListener listener: listenerInputValue) {
					listener.inputValue(channel, changed, value);
				}
			}
		};

		callbacks[CALLBACK_ALL_INPUT_VALUE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				byte[] changedBits = new byte[2];
				bb.get(changedBits);
				boolean[] changed = new boolean[16];
				for (int i = 0; i < 16; i++) {
					changed[i] = (changedBits[i / 8] & (1 << (i % 8))) != 0;
				}

				byte[] valueBits = new byte[2];
				bb.get(valueBits);
				boolean[] value = new boolean[16];
				for (int i = 0; i < 16; i++) {
					value[i] = (valueBits[i / 8] & (1 << (i % 8))) != 0;
				}


				for (AllInputValueListener listener: listenerAllInputValue) {
					listener.allInputValue(changed, value);
				}
			}
		};

		callbacks[CALLBACK_MONOFLOP_DONE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int channel = IPConnection.unsignedByte(bb.get());
				boolean value = (bb.get()) != 0;

				for (MonoflopDoneListener listener: listenerMonoflopDone) {
					listener.monoflopDone(channel, value);
				}
			}
		};
	}

	/**
	 * Sets the output value of all sixteen channels. A value of *true* or *false* outputs
	 * logic 1 or logic 0 respectively on the corresponding channel.
	 * 
	 * Use {@link BrickletIO16V2#setSelectedValue(int, boolean)} to change only one output channel state.
	 * 
	 * For example: (True, True, False, False, ..., False) will turn the channels 0-1
	 * high and the channels 2-15 low.
	 * 
	 * All running monoflop timers will be aborted if this function is called.
	 * 
	 * \note
	 *  This function does nothing for channels that are configured as input. Pull-up
	 *  resistors can be switched on with {@link BrickletIO16V2#setConfiguration(int, char, boolean)}.
	 */
	public void setValue(boolean[] value) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_VALUE, this);


		byte[] valueBits = new byte[2];
		Arrays.fill(valueBits, (byte)0);

		for (int i = 0; i < 16; i++) {
			if (value[i]) {
				valueBits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 2; i++) {
			bb.put(valueBits[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the logic levels that are currently measured on the channels.
	 * This function works if the channel is configured as input as well as if it is
	 * configured as output.
	 */
	public boolean[] getValue() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VALUE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		byte[] valueBits = new byte[2];
		bb.get(valueBits);
		boolean[] value = new boolean[16];
		for (int i = 0; i < 16; i++) {
			value[i] = (valueBits[i / 8] & (1 << (i % 8))) != 0;
		}


		return value;
	}

	/**
	 * Sets the output value of a specific channel without affecting the other channels.
	 * 
	 * A running monoflop timer for the specific channel will be aborted if this
	 * function is called.
	 * 
	 * \note
	 *  This function does nothing for channels that are configured as input. Pull-up
	 *  resistors can be switched on with {@link BrickletIO16V2#setConfiguration(int, char, boolean)}.
	 */
	public void setSelectedValue(int channel, boolean value) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_SELECTED_VALUE, this);

		bb.put((byte)channel);
		bb.put((byte)(value ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Configures the value and direction of a specific channel. Possible directions
	 * are 'i' and 'o' for input and output.
	 * 
	 * If the direction is configured as output, the value is either high or low
	 * (set as *true* or *false*).
	 * 
	 * If the direction is configured as input, the value is either pull-up or
	 * default (set as *true* or *false*).
	 * 
	 * For example:
	 * 
	 * * (0, 'i', true) will set channel-0 as input pull-up.
	 * * (1, 'i', false) will set channel-1 as input default (floating if nothing is connected).
	 * * (2, 'o', true) will set channel-2 as output high.
	 * * (3, 'o', false) will set channel-3 as output low.
	 * 
	 * A running monoflop timer for the specific channel will be aborted if this
	 * function is called.
	 * 
	 * The default configuration is input with pull-up.
	 */
	public void setConfiguration(int channel, char direction, boolean value) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_CONFIGURATION, this);

		bb.put((byte)channel);
		bb.put((byte)direction);
		bb.put((byte)(value ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the channel configuration as set by {@link BrickletIO16V2#setConfiguration(int, char, boolean)}.
	 */
	public Configuration getConfiguration(int channel) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CONFIGURATION, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.direction = (char)(bb.get());
		obj.value = (bb.get()) != 0;

		return obj;
	}

	/**
	 * This listener can be configured per channel.
	 * 
	 * The period in ms is the period with which the {@link BrickletIO16V2.InputValueListener}
	 * listener is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change within the
	 * period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * The default value is (0, false).
	 */
	public void setInputValueCallbackConfiguration(int channel, long period, boolean valueHasToChange) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_SET_INPUT_VALUE_CALLBACK_CONFIGURATION, this);

		bb.put((byte)channel);
		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletIO16V2#setInputValueCallbackConfiguration(int, long, boolean)}.
	 */
	public InputValueCallbackConfiguration getInputValueCallbackConfiguration(int channel) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_INPUT_VALUE_CALLBACK_CONFIGURATION, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		InputValueCallbackConfiguration obj = new InputValueCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * The period in ms is the period with which the {@link BrickletIO16V2.AllInputValueListener}
	 * listener is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change within the
	 * period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * The default value is (0, false).
	 */
	public void setAllInputValueCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletIO16V2#setAllInputValueCallbackConfiguration(long, boolean)}.
	 */
	public AllInputValueCallbackConfiguration getAllInputValueCallbackConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AllInputValueCallbackConfiguration obj = new AllInputValueCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Configures a monoflop of the specified channel.
	 * 
	 * The second parameter is the desired value of the specified
	 * channel. A *true* means relay closed and a *false* means relay open.
	 * 
	 * The third parameter indicates the time (in ms) that the channels should hold
	 * the value.
	 * 
	 * If this function is called with the parameters (0, 1, 1500) channel 0 will
	 * close and in 1.5s channel 0 will open again
	 * 
	 * A monoflop can be used as a fail-safe mechanism. For example: Lets assume you
	 * have a RS485 bus and a IO-16 Bricklet 2.0 connected to one of
	 * the slave stacks. You can now call this function every second, with a time
	 * parameter of two seconds and channel 0 closed. Channel 0 will be closed all the
	 * time. If now the RS485 connection is lost, then channel 0 will be opened in at
	 * most two seconds.
	 */
	public void setMonoflop(int channel, boolean value, long time) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_SET_MONOFLOP, this);

		bb.put((byte)channel);
		bb.put((byte)(value ? 1 : 0));
		bb.putInt((int)time);

		sendRequest(bb.array());
	}

	/**
	 * Returns (for the given channel) the current value and the time as set by
	 * {@link BrickletIO16V2#setMonoflop(int, boolean, long)} as well as the remaining time until the value flips.
	 * 
	 * If the timer is not running currently, the remaining time will be returned
	 * as 0.
	 */
	public Monoflop getMonoflop(int channel) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_MONOFLOP, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Monoflop obj = new Monoflop();
		obj.value = (bb.get()) != 0;
		obj.time = IPConnection.unsignedInt(bb.getInt());
		obj.timeRemaining = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Returns the current value of the edge counter for the selected channel. You can
	 * configure the edges that are counted with {@link BrickletIO16V2#setEdgeCountConfiguration(int, int, int)}.
	 * 
	 * If you set the reset counter to *true*, the count is set back to 0
	 * directly after it is read.
	 */
	public long getEdgeCount(int channel, boolean resetCounter) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_GET_EDGE_COUNT, this);

		bb.put((byte)channel);
		bb.put((byte)(resetCounter ? 1 : 0));

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long count = IPConnection.unsignedInt(bb.getInt());

		return count;
	}

	/**
	 * Configures the edge counter for a specific channel.
	 * 
	 * The edge type parameter configures if rising edges, falling edges or
	 * both are counted if the channel is configured for input. Possible edge types are:
	 * 
	 * * 0 = rising (default)
	 * * 1 = falling
	 * * 2 = both
	 * 
	 * The debounce time is given in ms.
	 * 
	 * Configuring an edge counter resets its value to 0.
	 * 
	 * If you don't know what any of this means, just leave it at default. The
	 * default configuration is very likely OK for you.
	 * 
	 * Default values: 0 (edge type) and 100ms (debounce time)
	 */
	public void setEdgeCountConfiguration(int channel, int edgeType, int debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_EDGE_COUNT_CONFIGURATION, this);

		bb.put((byte)channel);
		bb.put((byte)edgeType);
		bb.put((byte)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the edge type and debounce time for the selected channel as set by
	 * {@link BrickletIO16V2#setEdgeCountConfiguration(int, int, int)}.
	 */
	public EdgeCountConfiguration getEdgeCountConfiguration(int channel) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_EDGE_COUNT_CONFIGURATION, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		EdgeCountConfiguration obj = new EdgeCountConfiguration();
		obj.edgeType = IPConnection.unsignedByte(bb.get());
		obj.debounce = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletIO16V2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletIO16V2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletIO16V2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletIO16V2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature in °C as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a InputValue listener.
	 */
	public void addInputValueListener(InputValueListener listener) {
		listenerInputValue.add(listener);
	}

	/**
	 * Removes a InputValue listener.
	 */
	public void removeInputValueListener(InputValueListener listener) {
		listenerInputValue.remove(listener);
	}

	/**
	 * Adds a AllInputValue listener.
	 */
	public void addAllInputValueListener(AllInputValueListener listener) {
		listenerAllInputValue.add(listener);
	}

	/**
	 * Removes a AllInputValue listener.
	 */
	public void removeAllInputValueListener(AllInputValueListener listener) {
		listenerAllInputValue.remove(listener);
	}

	/**
	 * Adds a MonoflopDone listener.
	 */
	public void addMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.add(listener);
	}

	/**
	 * Removes a MonoflopDone listener.
	 */
	public void removeMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIO16V2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIO16V2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIO16V2Config cfg = (BrickletIO16V2Config) config.as(BrickletIO16V2Config.class);
        this.addInputValueListener((channel, changed, value) -> {if(channel == 0) {updateStateFn.accept("IO16V2InputPin0", transformIO16V2InputPin0Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 1) {updateStateFn.accept("IO16V2InputPin1", transformIO16V2InputPin1Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 2) {updateStateFn.accept("IO16V2InputPin2", transformIO16V2InputPin2Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 3) {updateStateFn.accept("IO16V2InputPin3", transformIO16V2InputPin3Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 4) {updateStateFn.accept("IO16V2InputPin4", transformIO16V2InputPin4Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 5) {updateStateFn.accept("IO16V2InputPin5", transformIO16V2InputPin5Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 6) {updateStateFn.accept("IO16V2InputPin6", transformIO16V2InputPin6Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 7) {updateStateFn.accept("IO16V2InputPin7", transformIO16V2InputPin7Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 8) {updateStateFn.accept("IO16V2InputPin8", transformIO16V2InputPin8Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 9) {updateStateFn.accept("IO16V2InputPin9", transformIO16V2InputPin9Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 10) {updateStateFn.accept("IO16V2InputPin10", transformIO16V2InputPin10Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 11) {updateStateFn.accept("IO16V2InputPin11", transformIO16V2InputPin11Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 12) {updateStateFn.accept("IO16V2InputPin12", transformIO16V2InputPin12Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 13) {updateStateFn.accept("IO16V2InputPin13", transformIO16V2InputPin13Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 14) {updateStateFn.accept("IO16V2InputPin14", transformIO16V2InputPin14Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 15) {updateStateFn.accept("IO16V2InputPin15", transformIO16V2InputPin15Callback0(channel, changed, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 0) {updateStateFn.accept("IO16V2OutputPin0", transformIO16V2OutputPin0Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 1) {updateStateFn.accept("IO16V2OutputPin1", transformIO16V2OutputPin1Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 2) {updateStateFn.accept("IO16V2OutputPin2", transformIO16V2OutputPin2Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 3) {updateStateFn.accept("IO16V2OutputPin3", transformIO16V2OutputPin3Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 4) {updateStateFn.accept("IO16V2OutputPin4", transformIO16V2OutputPin4Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 5) {updateStateFn.accept("IO16V2OutputPin5", transformIO16V2OutputPin5Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 6) {updateStateFn.accept("IO16V2OutputPin6", transformIO16V2OutputPin6Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 7) {updateStateFn.accept("IO16V2OutputPin7", transformIO16V2OutputPin7Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 8) {updateStateFn.accept("IO16V2OutputPin8", transformIO16V2OutputPin8Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 9) {updateStateFn.accept("IO16V2OutputPin9", transformIO16V2OutputPin9Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 10) {updateStateFn.accept("IO16V2OutputPin10", transformIO16V2OutputPin10Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 11) {updateStateFn.accept("IO16V2OutputPin11", transformIO16V2OutputPin11Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 12) {updateStateFn.accept("IO16V2OutputPin12", transformIO16V2OutputPin12Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 13) {updateStateFn.accept("IO16V2OutputPin13", transformIO16V2OutputPin13Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 14) {updateStateFn.accept("IO16V2OutputPin14", transformIO16V2OutputPin14Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 15) {updateStateFn.accept("IO16V2OutputPin15", transformIO16V2OutputPin15Callback0(channel, value, cfg));}});
        
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin0").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(0, 'i', cfg.pinConfiguration0 % 2 == 1);
		            this.setInputValueCallbackConfiguration(0, 1000, false);
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin1").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(1, 'i', cfg.pinConfiguration1 % 2 == 1);
		            this.setInputValueCallbackConfiguration(1, 1000, false);
		}
		if (cfg.pinConfiguration2 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin2").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(2, 'i', cfg.pinConfiguration2 % 2 == 1);
		            this.setInputValueCallbackConfiguration(2, 1000, false);
		}
		if (cfg.pinConfiguration3 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin3").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(3, 'i', cfg.pinConfiguration3 % 2 == 1);
		            this.setInputValueCallbackConfiguration(3, 1000, false);
		}
		if (cfg.pinConfiguration4 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin4").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(4, 'i', cfg.pinConfiguration4 % 2 == 1);
		            this.setInputValueCallbackConfiguration(4, 1000, false);
		}
		if (cfg.pinConfiguration5 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin5").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(5, 'i', cfg.pinConfiguration5 % 2 == 1);
		            this.setInputValueCallbackConfiguration(5, 1000, false);
		}
		if (cfg.pinConfiguration6 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin6").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(6, 'i', cfg.pinConfiguration6 % 2 == 1);
		            this.setInputValueCallbackConfiguration(6, 1000, false);
		}
		if (cfg.pinConfiguration7 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin7").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(7, 'i', cfg.pinConfiguration7 % 2 == 1);
		            this.setInputValueCallbackConfiguration(7, 1000, false);
		}
		if (cfg.pinConfiguration8 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin8").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(8, 'i', cfg.pinConfiguration8 % 2 == 1);
		            this.setInputValueCallbackConfiguration(8, 1000, false);
		}
		if (cfg.pinConfiguration9 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin9").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(9, 'i', cfg.pinConfiguration9 % 2 == 1);
		            this.setInputValueCallbackConfiguration(9, 1000, false);
		}
		if (cfg.pinConfiguration10 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin10").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(10, 'i', cfg.pinConfiguration10 % 2 == 1);
		            this.setInputValueCallbackConfiguration(10, 1000, false);
		}
		if (cfg.pinConfiguration11 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin11").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(11, 'i', cfg.pinConfiguration11 % 2 == 1);
		            this.setInputValueCallbackConfiguration(11, 1000, false);
		}
		if (cfg.pinConfiguration12 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin12").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(12, 'i', cfg.pinConfiguration12 % 2 == 1);
		            this.setInputValueCallbackConfiguration(12, 1000, false);
		}
		if (cfg.pinConfiguration13 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin13").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(13, 'i', cfg.pinConfiguration13 % 2 == 1);
		            this.setInputValueCallbackConfiguration(13, 1000, false);
		}
		if (cfg.pinConfiguration14 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin14").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(14, 'i', cfg.pinConfiguration14 % 2 == 1);
		            this.setInputValueCallbackConfiguration(14, 1000, false);
		}
		if (cfg.pinConfiguration15 > 1) {
		BrickletIO16V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2InputPin15").as(BrickletIO16V2InputPinConfig.class);
		this.setConfiguration(15, 'i', cfg.pinConfiguration15 % 2 == 1);
		            this.setInputValueCallbackConfiguration(15, 1000, false);
		}
		if (cfg.pinConfiguration0 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin0").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(0, 'o', cfg.pinConfiguration0 % 2 == 1);
		}
		if (cfg.pinConfiguration1 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin1").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(1, 'o', cfg.pinConfiguration1 % 2 == 1);
		}
		if (cfg.pinConfiguration2 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin2").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(2, 'o', cfg.pinConfiguration2 % 2 == 1);
		}
		if (cfg.pinConfiguration3 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin3").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(3, 'o', cfg.pinConfiguration3 % 2 == 1);
		}
		if (cfg.pinConfiguration4 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin4").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(4, 'o', cfg.pinConfiguration4 % 2 == 1);
		}
		if (cfg.pinConfiguration5 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin5").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(5, 'o', cfg.pinConfiguration5 % 2 == 1);
		}
		if (cfg.pinConfiguration6 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin6").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(6, 'o', cfg.pinConfiguration6 % 2 == 1);
		}
		if (cfg.pinConfiguration7 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin7").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(7, 'o', cfg.pinConfiguration7 % 2 == 1);
		}
		if (cfg.pinConfiguration8 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin8").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(8, 'o', cfg.pinConfiguration8 % 2 == 1);
		}
		if (cfg.pinConfiguration9 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin9").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(9, 'o', cfg.pinConfiguration9 % 2 == 1);
		}
		if (cfg.pinConfiguration10 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin10").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(10, 'o', cfg.pinConfiguration10 % 2 == 1);
		}
		if (cfg.pinConfiguration11 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin11").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(11, 'o', cfg.pinConfiguration11 % 2 == 1);
		}
		if (cfg.pinConfiguration12 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin12").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(12, 'o', cfg.pinConfiguration12 % 2 == 1);
		}
		if (cfg.pinConfiguration13 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin13").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(13, 'o', cfg.pinConfiguration13 % 2 == 1);
		}
		if (cfg.pinConfiguration14 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin14").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(14, 'o', cfg.pinConfiguration14 % 2 == 1);
		}
		if (cfg.pinConfiguration15 <= 1) {
		BrickletIO16V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16V2OutputPin15").as(BrickletIO16V2OutputPinConfig.class);
		this.setConfiguration(15, 'o', cfg.pinConfiguration15 % 2 == 1);
		}
		if (cfg.pinConfiguration0 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin0").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration1 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin1").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration2 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin2").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration3 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin3").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration4 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin4").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration5 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin5").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration6 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin6").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration7 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin7").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration8 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin8").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration9 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin9").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration10 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin10").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration11 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin11").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration12 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin12").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration13 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin13").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration14 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin14").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration15 <= 1) {
		BrickletIO16V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16V2MonoflopPin15").as(BrickletIO16V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin0").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(0, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin1").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(1, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration2 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin2").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(2, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration3 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin3").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(3, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration4 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin4").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(4, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration5 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin5").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(5, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration6 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin6").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(6, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration7 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin7").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(7, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration8 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin8").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(8, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration9 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin9").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(9, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration10 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin10").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(10, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration11 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin11").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(11, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration12 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin12").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(12, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration13 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin13").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(13, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration14 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin14").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(14, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration15 > 1) {
		BrickletIO16V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16V2EdgeCountPin15").as(BrickletIO16V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(15, channelCfg.edgeType, channelCfg.debounce);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIO16V2Config cfg = (BrickletIO16V2Config) config.as(BrickletIO16V2Config.class);
        this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
        this.setInputValueCallbackConfiguration(0, 0, false);
		this.setInputValueCallbackConfiguration(1, 0, false);
		this.setInputValueCallbackConfiguration(2, 0, false);
		this.setInputValueCallbackConfiguration(3, 0, false);
		this.setInputValueCallbackConfiguration(4, 0, false);
		this.setInputValueCallbackConfiguration(5, 0, false);
		this.setInputValueCallbackConfiguration(6, 0, false);
		this.setInputValueCallbackConfiguration(7, 0, false);
		this.setInputValueCallbackConfiguration(8, 0, false);
		this.setInputValueCallbackConfiguration(9, 0, false);
		this.setInputValueCallbackConfiguration(10, 0, false);
		this.setInputValueCallbackConfiguration(11, 0, false);
		this.setInputValueCallbackConfiguration(12, 0, false);
		this.setInputValueCallbackConfiguration(13, 0, false);
		this.setInputValueCallbackConfiguration(14, 0, false);
		this.setInputValueCallbackConfiguration(15, 0, false);
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIO16V2Config cfg = (BrickletIO16V2Config) config.as(BrickletIO16V2Config.class);
        List<String> result = new ArrayList<String>();
        if (cfg.pinConfiguration0 > 1) {
                result.add("IO16V2InputPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("IO16V2InputPin1");
            }
		if (cfg.pinConfiguration2 > 1) {
                result.add("IO16V2InputPin2");
            }
		if (cfg.pinConfiguration3 > 1) {
                result.add("IO16V2InputPin3");
            }
		if (cfg.pinConfiguration4 > 1) {
                result.add("IO16V2InputPin4");
            }
		if (cfg.pinConfiguration5 > 1) {
                result.add("IO16V2InputPin5");
            }
		if (cfg.pinConfiguration6 > 1) {
                result.add("IO16V2InputPin6");
            }
		if (cfg.pinConfiguration7 > 1) {
                result.add("IO16V2InputPin7");
            }
		if (cfg.pinConfiguration8 > 1) {
                result.add("IO16V2InputPin8");
            }
		if (cfg.pinConfiguration9 > 1) {
                result.add("IO16V2InputPin9");
            }
		if (cfg.pinConfiguration10 > 1) {
                result.add("IO16V2InputPin10");
            }
		if (cfg.pinConfiguration11 > 1) {
                result.add("IO16V2InputPin11");
            }
		if (cfg.pinConfiguration12 > 1) {
                result.add("IO16V2InputPin12");
            }
		if (cfg.pinConfiguration13 > 1) {
                result.add("IO16V2InputPin13");
            }
		if (cfg.pinConfiguration14 > 1) {
                result.add("IO16V2InputPin14");
            }
		if (cfg.pinConfiguration15 > 1) {
                result.add("IO16V2InputPin15");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("IO16V2OutputPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("IO16V2OutputPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("IO16V2OutputPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("IO16V2OutputPin3");
            }
		if (cfg.pinConfiguration4 <= 1) {
                result.add("IO16V2OutputPin4");
            }
		if (cfg.pinConfiguration5 <= 1) {
                result.add("IO16V2OutputPin5");
            }
		if (cfg.pinConfiguration6 <= 1) {
                result.add("IO16V2OutputPin6");
            }
		if (cfg.pinConfiguration7 <= 1) {
                result.add("IO16V2OutputPin7");
            }
		if (cfg.pinConfiguration8 <= 1) {
                result.add("IO16V2OutputPin8");
            }
		if (cfg.pinConfiguration9 <= 1) {
                result.add("IO16V2OutputPin9");
            }
		if (cfg.pinConfiguration10 <= 1) {
                result.add("IO16V2OutputPin10");
            }
		if (cfg.pinConfiguration11 <= 1) {
                result.add("IO16V2OutputPin11");
            }
		if (cfg.pinConfiguration12 <= 1) {
                result.add("IO16V2OutputPin12");
            }
		if (cfg.pinConfiguration13 <= 1) {
                result.add("IO16V2OutputPin13");
            }
		if (cfg.pinConfiguration14 <= 1) {
                result.add("IO16V2OutputPin14");
            }
		if (cfg.pinConfiguration15 <= 1) {
                result.add("IO16V2OutputPin15");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("IO16V2MonoflopPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("IO16V2MonoflopPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("IO16V2MonoflopPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("IO16V2MonoflopPin3");
            }
		if (cfg.pinConfiguration4 <= 1) {
                result.add("IO16V2MonoflopPin4");
            }
		if (cfg.pinConfiguration5 <= 1) {
                result.add("IO16V2MonoflopPin5");
            }
		if (cfg.pinConfiguration6 <= 1) {
                result.add("IO16V2MonoflopPin6");
            }
		if (cfg.pinConfiguration7 <= 1) {
                result.add("IO16V2MonoflopPin7");
            }
		if (cfg.pinConfiguration8 <= 1) {
                result.add("IO16V2MonoflopPin8");
            }
		if (cfg.pinConfiguration9 <= 1) {
                result.add("IO16V2MonoflopPin9");
            }
		if (cfg.pinConfiguration10 <= 1) {
                result.add("IO16V2MonoflopPin10");
            }
		if (cfg.pinConfiguration11 <= 1) {
                result.add("IO16V2MonoflopPin11");
            }
		if (cfg.pinConfiguration12 <= 1) {
                result.add("IO16V2MonoflopPin12");
            }
		if (cfg.pinConfiguration13 <= 1) {
                result.add("IO16V2MonoflopPin13");
            }
		if (cfg.pinConfiguration14 <= 1) {
                result.add("IO16V2MonoflopPin14");
            }
		if (cfg.pinConfiguration15 <= 1) {
                result.add("IO16V2MonoflopPin15");
            }
		if (cfg.pinConfiguration0 > 1) {
                result.add("IO16V2EdgeCountPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("IO16V2EdgeCountPin1");
            }
		if (cfg.pinConfiguration2 > 1) {
                result.add("IO16V2EdgeCountPin2");
            }
		if (cfg.pinConfiguration3 > 1) {
                result.add("IO16V2EdgeCountPin3");
            }
		if (cfg.pinConfiguration4 > 1) {
                result.add("IO16V2EdgeCountPin4");
            }
		if (cfg.pinConfiguration5 > 1) {
                result.add("IO16V2EdgeCountPin5");
            }
		if (cfg.pinConfiguration6 > 1) {
                result.add("IO16V2EdgeCountPin6");
            }
		if (cfg.pinConfiguration7 > 1) {
                result.add("IO16V2EdgeCountPin7");
            }
		if (cfg.pinConfiguration8 > 1) {
                result.add("IO16V2EdgeCountPin8");
            }
		if (cfg.pinConfiguration9 > 1) {
                result.add("IO16V2EdgeCountPin9");
            }
		if (cfg.pinConfiguration10 > 1) {
                result.add("IO16V2EdgeCountPin10");
            }
		if (cfg.pinConfiguration11 > 1) {
                result.add("IO16V2EdgeCountPin11");
            }
		if (cfg.pinConfiguration12 > 1) {
                result.add("IO16V2EdgeCountPin12");
            }
		if (cfg.pinConfiguration13 > 1) {
                result.add("IO16V2EdgeCountPin13");
            }
		if (cfg.pinConfiguration14 > 1) {
                result.add("IO16V2EdgeCountPin14");
            }
		if (cfg.pinConfiguration15 > 1) {
                result.add("IO16V2EdgeCountPin15");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "IO16V2InputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO16V2InputPin"), "Input Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO16V2InputPin")).withDescription("The logic level that is currently measured on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "IO16V2OutputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO16V2OutputPin"), "Output Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO16V2OutputPin")).withDescription("The logic level that is currently set on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "IO16V2Monoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO16V2Monoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO16V2Monoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            case "IO16V2EdgeCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount"), "Edge Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO16V2EdgeCount")).withDescription("The current value of the edge counter for the selected channel")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge IO-16 Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("16-channel digital input/output").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("IO16V2InputPin0", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 0/A0").build(), new ChannelDefinitionBuilder("IO16V2InputPin1", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 1/A1").build(), new ChannelDefinitionBuilder("IO16V2InputPin2", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 2/A2").build(), new ChannelDefinitionBuilder("IO16V2InputPin3", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 3/A3").build(), new ChannelDefinitionBuilder("IO16V2InputPin4", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 4/A4").build(), new ChannelDefinitionBuilder("IO16V2InputPin5", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 5/A5").build(), new ChannelDefinitionBuilder("IO16V2InputPin6", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 6/A6").build(), new ChannelDefinitionBuilder("IO16V2InputPin7", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 7/A7").build(), new ChannelDefinitionBuilder("IO16V2InputPin8", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 8/B0").build(), new ChannelDefinitionBuilder("IO16V2InputPin9", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 9/B1").build(), new ChannelDefinitionBuilder("IO16V2InputPin10", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 10/B2").build(), new ChannelDefinitionBuilder("IO16V2InputPin11", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 11/B3").build(), new ChannelDefinitionBuilder("IO16V2InputPin12", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 12/B4").build(), new ChannelDefinitionBuilder("IO16V2InputPin13", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 13/B5").build(), new ChannelDefinitionBuilder("IO16V2InputPin14", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 14/B6").build(), new ChannelDefinitionBuilder("IO16V2InputPin15", new ChannelTypeUID("tinkerforge", "IO16V2InputPin")).withLabel("Input Value Pin 15/B7").build(), new ChannelDefinitionBuilder("IO16V2OutputPin0", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 0/A0").build(), new ChannelDefinitionBuilder("IO16V2OutputPin1", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 1/A1").build(), new ChannelDefinitionBuilder("IO16V2OutputPin2", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 2/A2").build(), new ChannelDefinitionBuilder("IO16V2OutputPin3", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 3/A3").build(), new ChannelDefinitionBuilder("IO16V2OutputPin4", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 4/A4").build(), new ChannelDefinitionBuilder("IO16V2OutputPin5", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 5/A5").build(), new ChannelDefinitionBuilder("IO16V2OutputPin6", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 6/A6").build(), new ChannelDefinitionBuilder("IO16V2OutputPin7", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 7/A7").build(), new ChannelDefinitionBuilder("IO16V2OutputPin8", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 8/B0").build(), new ChannelDefinitionBuilder("IO16V2OutputPin9", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 9/B1").build(), new ChannelDefinitionBuilder("IO16V2OutputPin10", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 10/B2").build(), new ChannelDefinitionBuilder("IO16V2OutputPin11", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 11/B3").build(), new ChannelDefinitionBuilder("IO16V2OutputPin12", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 12/B4").build(), new ChannelDefinitionBuilder("IO16V2OutputPin13", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 13/B5").build(), new ChannelDefinitionBuilder("IO16V2OutputPin14", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 14/B6").build(), new ChannelDefinitionBuilder("IO16V2OutputPin15", new ChannelTypeUID("tinkerforge", "IO16V2OutputPin")).withLabel("Output Value Pin 15/B7").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin0", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 0/A0").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin1", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 1/A1").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin2", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 2/A2").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin3", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 3/A3").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin4", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 4/A4").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin5", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 5/A5").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin6", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 6/A6").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin7", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 7/A7").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin8", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 8/B0").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin9", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 9/B1").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin10", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 10/B2").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin11", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 11/B3").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin12", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 12/B4").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin13", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 13/B5").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin14", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 14/B6").build(), new ChannelDefinitionBuilder("IO16V2MonoflopPin15", new ChannelTypeUID("tinkerforge", "IO16V2Monoflop")).withLabel("Monoflop Pin 15/B7").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin0", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 0/A0").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin1", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 1/A1").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin2", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 2/A2").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin3", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 3/A3").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin4", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 4/A4").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin5", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 5/A5").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin6", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 6/A6").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin7", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 7/A7").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin8", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 8/B0").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin9", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 9/B1").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin10", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 10/B2").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin11", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 11/B3").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin12", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 12/B4").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin13", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 13/B5").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin14", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 14/B6").build(), new ChannelDefinitionBuilder("IO16V2EdgeCountPin15", new ChannelTypeUID("tinkerforge", "IO16V2EdgeCount")).withLabel("Edge Count Pin 15/B7").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:io16v2":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("pinConfiguration0", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 0/A0. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 0/A0").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration1", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 1/A1. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 1/A1").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration2", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 2/A2. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 2/A2").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration3", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 3/A3. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 3/A3").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration4", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 4/A4. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 4/A4").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration5", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 5/A5. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 5/A5").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration6", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 6/A6. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 6/A6").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration7", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 7/A7. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 7/A7").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration8", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 8/B0. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 8/B0").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration9", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 9/B1. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 9/B1").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration10", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 10/B2. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 10/B2").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration11", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 11/B3. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 11/B3").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration12", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 12/B4. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 12/B4").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration13", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 13/B5. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 13/B5").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration14", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 14/B6. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 14/B6").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration15", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 15/B7. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 15/B7").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build()));
            case "channel-type:tinkerforge:IO16V2InputPin":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IO16V2OutputPin":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IO16V2Monoflop":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the pin should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(2147483647)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").build()));
            case "channel-type:tinkerforge:IO16V2EdgeCount":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("edgeType", Type.INTEGER).withDefault("0").withDescription("The edge type parameter configures if rising edges, falling edges or both are counted.").withLabel("Edge Type").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Rising"), new ParameterOption("1", "Falling"), new ParameterOption("2", "Both"))).build(), ConfigDescriptionParameterBuilder.create("debounce", Type.INTEGER).withDefault("100").withDescription("The debounce time in ms.").withLabel("Debounce Time").build(), ConfigDescriptionParameterBuilder.create("resetOnRead", Type.BOOLEAN).withDefault("false").withDescription("Enabling this will reset the edge counter after OpenHAB reads its value. Use this if you want relative edge counts per update.").withLabel("Reset Edge Count On Update").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIO16V2Config cfg = (BrickletIO16V2Config) config.as(BrickletIO16V2Config.class);
        switch(value) {
            case "IO16V2InputPin0": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin0Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin1": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin1Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin2": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin2Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin3": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin3Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin4": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin4Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin5": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin5Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin6": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin6Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin7": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin7Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin8": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin8Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin9": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin9Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin10": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin10Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin11": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin11Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin12": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin12Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin13": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin13Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin14": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin14Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2InputPin15": {
                   BrickletIO16V2InputPinConfig channelCfg = channelConfig.as(BrickletIO16V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2InputPin15Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin0": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin0Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin1": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin1Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin2": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin2Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin3": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin3Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin4": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin4Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin5": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin5Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin6": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin6Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin7": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin7Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin8": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin8Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin9": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin9Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin10": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin10Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin11": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin11Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin12": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin12Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin13": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin13Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin14": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin14Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2OutputPin15": {
                   BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16V2OutputPin15Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO16V2MonoflopPin0": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin0Getter0(this.getMonoflop(0), cfg));
                   return;
               }
            case "IO16V2MonoflopPin1": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin1Getter0(this.getMonoflop(1), cfg));
                   return;
               }
            case "IO16V2MonoflopPin2": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin2Getter0(this.getMonoflop(2), cfg));
                   return;
               }
            case "IO16V2MonoflopPin3": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin3Getter0(this.getMonoflop(3), cfg));
                   return;
               }
            case "IO16V2MonoflopPin4": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin4Getter0(this.getMonoflop(4), cfg));
                   return;
               }
            case "IO16V2MonoflopPin5": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin5Getter0(this.getMonoflop(5), cfg));
                   return;
               }
            case "IO16V2MonoflopPin6": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin6Getter0(this.getMonoflop(6), cfg));
                   return;
               }
            case "IO16V2MonoflopPin7": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin7Getter0(this.getMonoflop(7), cfg));
                   return;
               }
            case "IO16V2MonoflopPin8": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin8Getter0(this.getMonoflop(8), cfg));
                   return;
               }
            case "IO16V2MonoflopPin9": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin9Getter0(this.getMonoflop(9), cfg));
                   return;
               }
            case "IO16V2MonoflopPin10": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin10Getter0(this.getMonoflop(10), cfg));
                   return;
               }
            case "IO16V2MonoflopPin11": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin11Getter0(this.getMonoflop(11), cfg));
                   return;
               }
            case "IO16V2MonoflopPin12": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin12Getter0(this.getMonoflop(12), cfg));
                   return;
               }
            case "IO16V2MonoflopPin13": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin13Getter0(this.getMonoflop(13), cfg));
                   return;
               }
            case "IO16V2MonoflopPin14": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin14Getter0(this.getMonoflop(14), cfg));
                   return;
               }
            case "IO16V2MonoflopPin15": {
                   BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16V2MonoflopPin15Getter0(this.getMonoflop(15), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin0": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin0Getter0(this.getEdgeCount(0, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin1": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin1Getter0(this.getEdgeCount(1, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin2": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin2Getter0(this.getEdgeCount(2, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin3": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin3Getter0(this.getEdgeCount(3, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin4": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin4Getter0(this.getEdgeCount(4, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin5": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin5Getter0(this.getEdgeCount(5, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin6": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin6Getter0(this.getEdgeCount(6, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin7": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin7Getter0(this.getEdgeCount(7, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin8": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin8Getter0(this.getEdgeCount(8, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin9": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin9Getter0(this.getEdgeCount(9, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin10": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin10Getter0(this.getEdgeCount(10, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin11": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin11Getter0(this.getEdgeCount(11, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin12": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin12Getter0(this.getEdgeCount(12, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin13": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin13Getter0(this.getEdgeCount(13, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin14": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin14Getter0(this.getEdgeCount(14, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16V2EdgeCountPin15": {
                   BrickletIO16V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16V2EdgeCountPin15Getter0(this.getEdgeCount(15, channelCfg.resetOnRead), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIO16V2Config cfg = (BrickletIO16V2Config) config.as(BrickletIO16V2Config.class);
        switch(channel) {
            case "IO16V2OutputPin0":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(0, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin1":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(1, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin2":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(2, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin3":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(3, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin4":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(4, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin5":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(5, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin6":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(6, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin7":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(7, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin8":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(8, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin9":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(9, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin10":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(10, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin11":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(11, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin12":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(12, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin13":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(13, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin14":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(14, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2OutputPin15":
                if (command instanceof OnOffType) {
                    BrickletIO16V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO16V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(15, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin0":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(0, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin0", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin1":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin1", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin2":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(2, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin2", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin3":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(3, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin3", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin4":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(4, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin4", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin5":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(5, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin5", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin6":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(6, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin6", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin7":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(7, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin7", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin8":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(8, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin8", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin9":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(9, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin9", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin10":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(10, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin10", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin11":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(11, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin11", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin12":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(12, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin12", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin13":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(13, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin13", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin14":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(14, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin14", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16V2MonoflopPin15":
                if (command instanceof StringType) {
                    BrickletIO16V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO16V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(15, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO16V2OutputPin15", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformIO16V2InputPin0Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin1Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin2Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin3Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin4Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin5Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin6Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin7Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin8Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin9Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin10Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin11Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin12Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin13Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin14Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin15Callback0(int channel, boolean changed, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin0Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin1Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin2Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin3Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin4Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin5Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin6Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin7Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin8Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin9Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin10Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin11Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin12Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin13Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin14Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin15Callback0(int channel, boolean value, BrickletIO16V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin0Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin1Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[1] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin2Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[2] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin3Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[3] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin4Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[4] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin5Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[5] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin6Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[6] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin7Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[7] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin8Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[8] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin9Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[9] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin10Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[10] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin11Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[11] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin12Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[12] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin13Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[13] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin14Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[14] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2InputPin15Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[15] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin0Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin1Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[1] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin2Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[2] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin3Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[3] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin4Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[4] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin5Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[5] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin6Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[6] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin7Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[7] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin8Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[8] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin9Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[9] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin10Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[10] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin11Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[11] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin12Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[12] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin13Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[13] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin14Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[14] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2OutputPin15Getter0(boolean[] value, BrickletIO16V2Config cfg) {
        return value[15] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin0Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin1Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin2Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin3Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin4Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin5Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin6Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin7Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin8Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin9Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin10Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin11Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin12Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin13Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin14Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2MonoflopPin15Getter0(Monoflop value, BrickletIO16V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin0Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin1Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin2Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin3Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin4Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin5Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin6Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin7Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin8Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin9Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin10Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin11Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin12Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin13Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin14Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16V2EdgeCountPin15Getter0(long value, BrickletIO16V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
}
