/* ***********************************************************
 * This file was automatically generated on 2019-09-27.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.DecimalType;

/**
 * Generates configurable DC voltage and current, 0V to 10V and 4mA to 20mA
 */
public class BrickletIndustrialAnalogOut extends Device {
	public final static int DEVICE_IDENTIFIER = 258;
	public final static String DEVICE_DISPLAY_NAME = "Industrial Analog Out Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "industrialanalogout", DEVICE_IDENTIFIER, BrickletIndustrialAnalogOut.class);

	public final static byte FUNCTION_ENABLE = (byte)1;
	public final static byte FUNCTION_DISABLE = (byte)2;
	public final static byte FUNCTION_IS_ENABLED = (byte)3;
	public final static byte FUNCTION_SET_VOLTAGE = (byte)4;
	public final static byte FUNCTION_GET_VOLTAGE = (byte)5;
	public final static byte FUNCTION_SET_CURRENT = (byte)6;
	public final static byte FUNCTION_GET_CURRENT = (byte)7;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)8;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)9;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;

	public final static short VOLTAGE_RANGE_0_TO_5V = (short)0;
	public final static short VOLTAGE_RANGE_0_TO_10V = (short)1;
	public final static short CURRENT_RANGE_4_TO_20MA = (short)0;
	public final static short CURRENT_RANGE_0_TO_20MA = (short)1;
	public final static short CURRENT_RANGE_0_TO_24MA = (short)2;


	public class Configuration {
		public short voltageRange;
		public short currentRange;

		public String toString() {
			return "[" + "voltageRange = " + voltageRange + ", " + "currentRange = " + currentRange + "]";
		}
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIndustrialAnalogOut(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_ENABLE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_DISABLE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_IS_ENABLED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CURRENT)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CURRENT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
	}

	/**
	 * Enables the output of voltage and current.
	 * 
	 * The default is disabled.
	 */
	public void enable() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_ENABLE, this);


		sendRequest(bb.array());
	}

	/**
	 * Disables the output of voltage and current.
	 * 
	 * The default is disabled.
	 */
	public void disable() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_DISABLE, this);


		sendRequest(bb.array());
	}

	/**
	 * Returns *true* if output of voltage and current is enabled, *false* otherwise.
	 */
	public boolean isEnabled() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_ENABLED, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enabled = (bb.get()) != 0;

		return enabled;
	}

	/**
	 * Sets the output voltage in mV.
	 * 
	 * The output voltage and output current are linked. Changing the output voltage
	 * also changes the output current.
	 */
	public void setVoltage(int voltage) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_VOLTAGE, this);

		bb.putShort((short)voltage);

		sendRequest(bb.array());
	}

	/**
	 * Returns the voltage as set by {@link BrickletIndustrialAnalogOut#setVoltage(int)}.
	 */
	public int getVoltage() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VOLTAGE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnection.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Sets the output current in µA.
	 * 
	 * The output current and output voltage are linked. Changing the output current
	 * also changes the output voltage.
	 */
	public void setCurrent(int current) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CURRENT, this);

		bb.putShort((short)current);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current as set by {@link BrickletIndustrialAnalogOut#setCurrent(int)}.
	 */
	public int getCurrent() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CURRENT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int current = IPConnection.unsignedShort(bb.getShort());

		return current;
	}

	/**
	 * Configures the voltage and current range.
	 * 
	 * Possible voltage ranges are:
	 * 
	 * * 0V to 5V
	 * * 0V to 10V (default)
	 * 
	 * Possible current ranges are:
	 * 
	 * * 4mA to 20mA (default)
	 * * 0mA to 20mA
	 * * 0mA to 24mA
	 * 
	 * The resolution will always be 12 bit. This means, that the
	 * precision is higher with a smaller range.
	 */
	public void setConfiguration(short voltageRange, short currentRange) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CONFIGURATION, this);

		bb.put((byte)voltageRange);
		bb.put((byte)currentRange);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletIndustrialAnalogOut#setConfiguration(short, short)}.
	 */
	public Configuration getConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.voltageRange = IPConnection.unsignedByte(bb.get());
		obj.currentRange = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialAnalogOut.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialAnalogOut.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialAnalogOutConfig cfg = (BrickletIndustrialAnalogOutConfig) config.as(BrickletIndustrialAnalogOutConfig.class);
        
        this.setConfiguration(cfg.voltageRange.shortValue(), cfg.currentRange.shortValue());
		{
		BrickletIndustrialAnalogOutEnabledConfig channelCfg = getChannelConfigFn.apply("IndustrialAnalogOutEnabled").as(BrickletIndustrialAnalogOutEnabledConfig.class);
		
		}
		if (cfg.controlVoltage == 0) {
		BrickletIndustrialAnalogOutCurrentConfig channelCfg = getChannelConfigFn.apply("IndustrialAnalogOutCurrent").as(BrickletIndustrialAnalogOutCurrentConfig.class);
		
		}
		if (cfg.controlVoltage == 1) {
		BrickletIndustrialAnalogOutVoltageConfig channelCfg = getChannelConfigFn.apply("IndustrialAnalogOutVoltage").as(BrickletIndustrialAnalogOutVoltageConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIndustrialAnalogOutConfig cfg = (BrickletIndustrialAnalogOutConfig) config.as(BrickletIndustrialAnalogOutConfig.class);
        
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialAnalogOutConfig cfg = (BrickletIndustrialAnalogOutConfig) config.as(BrickletIndustrialAnalogOutConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("IndustrialAnalogOutEnabled");
		if (cfg.controlVoltage == 0) {
                result.add("IndustrialAnalogOutCurrent");
            }
		if (cfg.controlVoltage == 1) {
                result.add("IndustrialAnalogOutVoltage");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "IndustrialAnalogOutEnabled":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IndustrialAnalogOutEnabled"), "Output Enabled", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IndustrialAnalogOutEnabled")).withDescription("Enables/disables the output of voltage and current.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "IndustrialAnalogOutVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IndustrialAnalogOutVoltage"), "Output Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IndustrialAnalogOutVoltage")).withDescription("The output voltage in V. The output voltage and output current are linked. Changing the output voltage also changes the output current.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(10)).withPattern("%.3f %unit%").withReadOnly(false).build().toStateDescription()).build();
            case "IndustrialAnalogOutCurrent":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IndustrialAnalogOutCurrent"), "Output Current", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IndustrialAnalogOutCurrent")).withDescription("The output current in A. The output current and output voltage are linked. Changing the output current also changes the output voltage.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(0.024)).withPattern("%.6f %unit%").withReadOnly(false).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Analog Out Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Generates configurable DC voltage and current, 0V to 10V and 4mA to 20mA").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("IndustrialAnalogOutEnabled", new ChannelTypeUID("tinkerforge", "IndustrialAnalogOutEnabled")).build(), new ChannelDefinitionBuilder("IndustrialAnalogOutCurrent", new ChannelTypeUID("tinkerforge", "IndustrialAnalogOutCurrent")).build(), new ChannelDefinitionBuilder("IndustrialAnalogOutVoltage", new ChannelTypeUID("tinkerforge", "IndustrialAnalogOutVoltage")).build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:industrialanalogout":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("controlVoltage", Type.INTEGER).withDefault("1").withDescription("Sets the output configuration. As the output voltage and current level depend on each other, only one can be controlled at the same time.").withLabel("Output Configuration").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Current"), new ParameterOption("1", "Voltage"))).build(), ConfigDescriptionParameterBuilder.create("voltageRange", Type.INTEGER).withDefault("1").withDescription("Configures the voltage range. The resolution will always be 12 bit. This means, that the precision is higher with a smaller range.").withLabel("Voltage Range").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "0 To 5V"), new ParameterOption("1", "0 To 10V"))).build(), ConfigDescriptionParameterBuilder.create("currentRange", Type.INTEGER).withDefault("1").withDescription("Configures the current range. The resolution will always be 12 bit. This means, that the precision is higher with a smaller range.").withLabel("Current Range").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "4 To 20mA"), new ParameterOption("1", "0 To 20mA"), new ParameterOption("2", "0 To 24mA"))).build()));
            case "channel-type:tinkerforge:IndustrialAnalogOutEnabled":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IndustrialAnalogOutVoltage":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IndustrialAnalogOutCurrent":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialAnalogOutConfig cfg = (BrickletIndustrialAnalogOutConfig) config.as(BrickletIndustrialAnalogOutConfig.class);
        switch(value) {
            case "IndustrialAnalogOutEnabled": {
                   BrickletIndustrialAnalogOutEnabledConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutEnabledConfig.class);
                   updateStateFn.accept(value, transformIndustrialAnalogOutEnabledGetter0(this.isEnabled(), cfg));
                   return;
               }
            case "IndustrialAnalogOutCurrent": {
                   BrickletIndustrialAnalogOutCurrentConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutCurrentConfig.class);
                   updateStateFn.accept(value, transformIndustrialAnalogOutCurrentGetter0(this.getCurrent(), cfg));
                   return;
               }
            case "IndustrialAnalogOutVoltage": {
                   BrickletIndustrialAnalogOutVoltageConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutVoltageConfig.class);
                   updateStateFn.accept(value, transformIndustrialAnalogOutVoltageGetter0(this.getVoltage(), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletIndustrialAnalogOutConfig cfg = (BrickletIndustrialAnalogOutConfig) config.as(BrickletIndustrialAnalogOutConfig.class);
        switch(channel) {
            case "IndustrialAnalogOutEnabled":
                if (command instanceof OnOffType) {
                    BrickletIndustrialAnalogOutEnabledConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutEnabledConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    if(cmd == OnOffType.ON) {
    this.enable();
}
                    if(cmd == OnOffType.OFF) {
    this.disable();
}
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialAnalogOutCurrent":
                if (command instanceof Number) {
                    BrickletIndustrialAnalogOutCurrentConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutCurrentConfig.class);
                    Number cmd = (Number) command;
                    this.setCurrent((int)(cmd.doubleValue() * 1000000.0));
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a Number.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialAnalogOutVoltage":
                if (command instanceof Number) {
                    BrickletIndustrialAnalogOutVoltageConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutVoltageConfig.class);
                    Number cmd = (Number) command;
                    this.setVoltage((int)(cmd.doubleValue() * 1000.0));
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a Number.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformIndustrialAnalogOutEnabledGetter0(boolean value, BrickletIndustrialAnalogOutConfig cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialAnalogOutCurrentGetter0(int value, BrickletIndustrialAnalogOutConfig cfg) {
        return new QuantityType(value / 1000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialAnalogOutVoltageGetter0(int value, BrickletIndustrialAnalogOutConfig cfg) {
        return new QuantityType(value / 1000.0, SmartHomeUnits.VOLT);
    }
}
