/* ***********************************************************
 * This file was automatically generated on 2019-09-27.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * Controls up to 2048 RGB(W) LEDs
 */
public class BrickletLEDStripV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2103;
	public final static String DEVICE_DISPLAY_NAME = "LED Strip Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "ledstripv2", DEVICE_IDENTIFIER, BrickletLEDStripV2.class);

	public final static byte FUNCTION_SET_LED_VALUES_LOW_LEVEL = (byte)1;
	public final static byte FUNCTION_GET_LED_VALUES_LOW_LEVEL = (byte)2;
	public final static byte FUNCTION_SET_FRAME_DURATION = (byte)3;
	public final static byte FUNCTION_GET_FRAME_DURATION = (byte)4;
	public final static byte FUNCTION_GET_SUPPLY_VOLTAGE = (byte)5;
	public final static byte FUNCTION_SET_CLOCK_FREQUENCY = (byte)7;
	public final static byte FUNCTION_GET_CLOCK_FREQUENCY = (byte)8;
	public final static byte FUNCTION_SET_CHIP_TYPE = (byte)9;
	public final static byte FUNCTION_GET_CHIP_TYPE = (byte)10;
	public final static byte FUNCTION_SET_CHANNEL_MAPPING = (byte)11;
	public final static byte FUNCTION_GET_CHANNEL_MAPPING = (byte)12;
	public final static byte FUNCTION_SET_FRAME_STARTED_CALLBACK_CONFIGURATION = (byte)13;
	public final static byte FUNCTION_GET_FRAME_STARTED_CALLBACK_CONFIGURATION = (byte)14;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_FRAME_STARTED = 6;

	public final static int CHIP_TYPE_WS2801 = 2801;
	public final static int CHIP_TYPE_WS2811 = 2811;
	public final static int CHIP_TYPE_WS2812 = 2812;
	public final static int CHIP_TYPE_LPD8806 = 8806;
	public final static int CHIP_TYPE_APA102 = 102;
	public final static int CHANNEL_MAPPING_RGB = 6;
	public final static int CHANNEL_MAPPING_RBG = 9;
	public final static int CHANNEL_MAPPING_BRG = 33;
	public final static int CHANNEL_MAPPING_BGR = 36;
	public final static int CHANNEL_MAPPING_GRB = 18;
	public final static int CHANNEL_MAPPING_GBR = 24;
	public final static int CHANNEL_MAPPING_RGBW = 27;
	public final static int CHANNEL_MAPPING_RGWB = 30;
	public final static int CHANNEL_MAPPING_RBGW = 39;
	public final static int CHANNEL_MAPPING_RBWG = 45;
	public final static int CHANNEL_MAPPING_RWGB = 54;
	public final static int CHANNEL_MAPPING_RWBG = 57;
	public final static int CHANNEL_MAPPING_GRWB = 78;
	public final static int CHANNEL_MAPPING_GRBW = 75;
	public final static int CHANNEL_MAPPING_GBWR = 108;
	public final static int CHANNEL_MAPPING_GBRW = 99;
	public final static int CHANNEL_MAPPING_GWBR = 120;
	public final static int CHANNEL_MAPPING_GWRB = 114;
	public final static int CHANNEL_MAPPING_BRGW = 135;
	public final static int CHANNEL_MAPPING_BRWG = 141;
	public final static int CHANNEL_MAPPING_BGRW = 147;
	public final static int CHANNEL_MAPPING_BGWR = 156;
	public final static int CHANNEL_MAPPING_BWRG = 177;
	public final static int CHANNEL_MAPPING_BWGR = 180;
	public final static int CHANNEL_MAPPING_WRBG = 201;
	public final static int CHANNEL_MAPPING_WRGB = 198;
	public final static int CHANNEL_MAPPING_WGBR = 216;
	public final static int CHANNEL_MAPPING_WGRB = 210;
	public final static int CHANNEL_MAPPING_WBGR = 228;
	public final static int CHANNEL_MAPPING_WBRG = 225;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<FrameStartedListener> listenerFrameStarted = new CopyOnWriteArrayList<FrameStartedListener>();

	public class LEDValuesLowLevel {
		public int valueLength;
		public int valueChunkOffset;
		public int[] valueChunkData = new int[60];

		public String toString() {
			return "[" + "valueLength = " + valueLength + ", " + "valueChunkOffset = " + valueChunkOffset + ", " + "valueChunkData = " + Arrays.toString(valueChunkData) + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered directly after a new frame render is started.
	 * The parameter is the number of LEDs in that frame.
	 * 
	 * You should send the data for the next frame directly after this listener
	 * was triggered.
	 * 
	 * For an explanation of the general approach see {@link BrickletLEDStripV2#setLEDValues(int, int[])}.
	 */
	public interface FrameStartedListener extends DeviceListener {
		public void frameStarted(int length);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletLEDStripV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_LED_VALUES_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_LED_VALUES_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_FRAME_DURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_FRAME_DURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SUPPLY_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CLOCK_FREQUENCY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CLOCK_FREQUENCY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CHIP_TYPE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TYPE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CHANNEL_MAPPING)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHANNEL_MAPPING)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_FRAME_STARTED_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_FRAME_STARTED_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_FRAME_STARTED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int length = IPConnection.unsignedShort(bb.getShort());

				for (FrameStartedListener listener: listenerFrameStarted) {
					listener.frameStarted(length);
				}
			}
		};
	}

	/**
	 * Sets the RGB(W) values for the LEDs starting from *index*.
	 * You can set at most 2048 RGB values or 1536 RGBW values.
	 * 
	 * To make the colors show correctly you need to configure the chip type
	 * (see {@link BrickletLEDStripV2#setChipType(int)}) and a channel mapping (see {@link BrickletLEDStripV2#setChannelMapping(int)})
	 * according to the connected LEDs.
	 * 
	 * If the channel mapping has 3 colors, you need to give the data in the sequence
	 * RGBRGBRGB... if the channel mapping has 4 colors you need to give data in the
	 * sequence RGBWRGBWRGBW...
	 * 
	 * The data is double buffered and the colors will be transfered to the
	 * LEDs when the next frame duration ends (see {@link BrickletLEDStripV2#setFrameDuration(int)}).
	 * 
	 * Generic approach:
	 * 
	 * * Set the frame duration to a value that represents the number of frames per
	 *   second you want to achieve.
	 * * Set all of the LED colors for one frame.
	 * * Wait for the {@link BrickletLEDStripV2.FrameStartedListener} listener.
	 * * Set all of the LED colors for next frame.
	 * * Wait for the {@link BrickletLEDStripV2.FrameStartedListener} listener.
	 * * And so on.
	 * 
	 * This approach ensures that you can change the LED colors with a fixed frame rate.
	 */
	public void setLEDValuesLowLevel(int index, int valueLength, int valueChunkOffset, int[] valueChunkData) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_SET_LED_VALUES_LOW_LEVEL, this);

		bb.putShort((short)index);
		bb.putShort((short)valueLength);
		bb.putShort((short)valueChunkOffset);
		for (int i = 0; i < 58; i++) {
			bb.put((byte)valueChunkData[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the RGB(W) values as set by {@link BrickletLEDStripV2#setLEDValues(int, int[])}.
	 */
	public LEDValuesLowLevel getLEDValuesLowLevel(int index, int length) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_GET_LED_VALUES_LOW_LEVEL, this);

		bb.putShort((short)index);
		bb.putShort((short)length);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		LEDValuesLowLevel obj = new LEDValuesLowLevel();
		obj.valueLength = IPConnection.unsignedShort(bb.getShort());
		obj.valueChunkOffset = IPConnection.unsignedShort(bb.getShort());
		for (int i = 0; i < 60; i++) {
			obj.valueChunkData[i] = IPConnection.unsignedByte(bb.get());
		}

		return obj;
	}

	/**
	 * Sets the frame duration in ms.
	 * 
	 * Example: If you want to achieve 20 frames per second, you should
	 * set the frame duration to 50ms (50ms * 20 = 1 second).
	 * 
	 * For an explanation of the general approach see {@link BrickletLEDStripV2#setLEDValues(int, int[])}.
	 * 
	 * Default value: 100ms (10 frames per second).
	 */
	public void setFrameDuration(int duration) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_FRAME_DURATION, this);

		bb.putShort((short)duration);

		sendRequest(bb.array());
	}

	/**
	 * Returns the frame duration in ms as set by {@link BrickletLEDStripV2#setFrameDuration(int)}.
	 */
	public int getFrameDuration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_FRAME_DURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int duration = IPConnection.unsignedShort(bb.getShort());

		return duration;
	}

	/**
	 * Returns the current supply voltage of the LEDs. The voltage is given in mV.
	 */
	public int getSupplyVoltage() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SUPPLY_VOLTAGE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnection.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Sets the frequency of the clock in Hz. The range is 10000Hz (10kHz) up to
	 * 2000000Hz (2MHz).
	 * 
	 * The Bricklet will choose the nearest achievable frequency, which may
	 * be off by a few Hz. You can get the exact frequency that is used by
	 * calling {@link BrickletLEDStripV2#getClockFrequency()}.
	 * 
	 * If you have problems with flickering LEDs, they may be bits flipping. You
	 * can fix this by either making the connection between the LEDs and the
	 * Bricklet shorter or by reducing the frequency.
	 * 
	 * With a decreasing frequency your maximum frames per second will decrease
	 * too.
	 * 
	 * The default value is 1.66MHz.
	 */
	public void setClockFrequency(long frequency) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_CLOCK_FREQUENCY, this);

		bb.putInt((int)frequency);

		sendRequest(bb.array());
	}

	/**
	 * Returns the currently used clock frequency as set by {@link BrickletLEDStripV2#setClockFrequency(long)}.
	 */
	public long getClockFrequency() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CLOCK_FREQUENCY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long frequency = IPConnection.unsignedInt(bb.getInt());

		return frequency;
	}

	/**
	 * Sets the type of the LED driver chip. We currently support the chips
	 * 
	 * * WS2801,
	 * * WS2811,
	 * * WS2812 / SK6812 / NeoPixel RGB,
	 * * SK6812RGBW / NeoPixel RGBW (Chip Type = WS2812),
	 * * LPD8806 and
	 * * APA102 / DotStar.
	 * 
	 * The default value is WS2801 (2801).
	 */
	public void setChipType(int chip) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CHIP_TYPE, this);

		bb.putShort((short)chip);

		sendRequest(bb.array());
	}

	/**
	 * Returns the currently used chip type as set by {@link BrickletLEDStripV2#setChipType(int)}.
	 */
	public int getChipType() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TYPE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int chip = IPConnection.unsignedShort(bb.getShort());

		return chip;
	}

	/**
	 * Sets the channel mapping for the connected LEDs.
	 * 
	 * If the mapping has 4 colors, the function {@link BrickletLEDStripV2#setLEDValues(int, int[])} expects 4
	 * values per pixel and if the mapping has 3 colors it expects 3 values per pixel.
	 * 
	 * The function always expects the order RGB(W). The connected LED driver chips
	 * might have their 3 or 4 channels in a different order. For example, the WS2801
	 * chips typically use BGR order, then WS2812 chips typically use GRB order and
	 * the APA102 chips typically use WBGR order.
	 * 
	 * The APA102 chips are special. They have three 8-bit channels for RGB
	 * and an additional 5-bit channel for the overall brightness of the RGB LED
	 * making them 4-channel chips. Internally the brightness channel is the first
	 * channel, therefore one of the Wxyz channel mappings should be used. Then
	 * the W channel controls the brightness.
	 * 
	 * The default value is BGR (36).
	 */
	public void setChannelMapping(int mapping) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_CHANNEL_MAPPING, this);

		bb.put((byte)mapping);

		sendRequest(bb.array());
	}

	/**
	 * Returns the currently used channel mapping as set by {@link BrickletLEDStripV2#setChannelMapping(int)}.
	 */
	public int getChannelMapping() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHANNEL_MAPPING, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mapping = IPConnection.unsignedByte(bb.get());

		return mapping;
	}

	/**
	 * Enables/disables the {@link BrickletLEDStripV2.FrameStartedListener} listener.
	 * 
	 * By default the listener is enabled.
	 */
	public void setFrameStartedCallbackConfiguration(boolean enable) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_FRAME_STARTED_CALLBACK_CONFIGURATION, this);

		bb.put((byte)(enable ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by
	 * {@link BrickletLEDStripV2#setFrameStartedCallbackConfiguration(boolean)}.
	 */
	public boolean getFrameStartedCallbackConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_FRAME_STARTED_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enable = (bb.get()) != 0;

		return enable;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletLEDStripV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletLEDStripV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletLEDStripV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletLEDStripV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature in °C as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Sets the RGB(W) values for the LEDs starting from *index*.
	 * You can set at most 2048 RGB values or 1536 RGBW values.
	 * 
	 * To make the colors show correctly you need to configure the chip type
	 * (see {@link BrickletLEDStripV2#setChipType(int)}) and a channel mapping (see {@link BrickletLEDStripV2#setChannelMapping(int)})
	 * according to the connected LEDs.
	 * 
	 * If the channel mapping has 3 colors, you need to give the data in the sequence
	 * RGBRGBRGB... if the channel mapping has 4 colors you need to give data in the
	 * sequence RGBWRGBWRGBW...
	 * 
	 * The data is double buffered and the colors will be transfered to the
	 * LEDs when the next frame duration ends (see {@link BrickletLEDStripV2#setFrameDuration(int)}).
	 * 
	 * Generic approach:
	 * 
	 * * Set the frame duration to a value that represents the number of frames per
	 *   second you want to achieve.
	 * * Set all of the LED colors for one frame.
	 * * Wait for the {@link BrickletLEDStripV2.FrameStartedListener} listener.
	 * * Set all of the LED colors for next frame.
	 * * Wait for the {@link BrickletLEDStripV2.FrameStartedListener} listener.
	 * * And so on.
	 * 
	 * This approach ensures that you can change the LED colors with a fixed frame rate.
	 */
	public void setLEDValues(int index, int[] value) throws TinkerforgeException {
		if (value.length > 65535) {
			throw new IllegalArgumentException("Value can be at most 65535 items long");
		}

		int valueLength = value.length;
		int valueChunkOffset = 0;
		int[] valueChunkData = new int[58];
		int valueChunkLength;

		if (valueLength == 0) {
			Arrays.fill(valueChunkData, 0);

			setLEDValuesLowLevel(index, valueLength, valueChunkOffset, valueChunkData);
		} else {
			synchronized (streamMutex) {
				while (valueChunkOffset < valueLength) {
					valueChunkLength = Math.min(valueLength - valueChunkOffset, 58);

					System.arraycopy(value, valueChunkOffset, valueChunkData, 0, valueChunkLength);
					Arrays.fill(valueChunkData, valueChunkLength, 58, 0);

					setLEDValuesLowLevel(index, valueLength, valueChunkOffset, valueChunkData);
					valueChunkOffset += 58;
				}
			}
		}
	}

	/**
	 * Returns the RGB(W) values as set by {@link BrickletLEDStripV2#setLEDValues(int, int[])}.
	 */
	public int[] getLEDValues(int index, int length) throws TinkerforgeException {
		LEDValuesLowLevel ret;
		int[] value = null; // stop the compiler from wrongly complaining that this variable is used unassigned
		int valueLength;
		int valueChunkOffset;
		int valueChunkLength;
		boolean valueOutOfSync;
		int valueCurrentLength;

		synchronized (streamMutex) {
			ret = getLEDValuesLowLevel(index, length);
			valueLength = ret.valueLength;
			valueChunkOffset = ret.valueChunkOffset;
			valueOutOfSync = valueChunkOffset != 0;

			if (!valueOutOfSync) {
				value = new int[valueLength];
				valueChunkLength = Math.min(valueLength - valueChunkOffset, 60);

				System.arraycopy(ret.valueChunkData, 0, value, 0, valueChunkLength);

				valueCurrentLength = valueChunkLength;

				while (valueCurrentLength < valueLength) {
					ret = getLEDValuesLowLevel(index, length);
					valueLength = ret.valueLength;
					valueOutOfSync = ret.valueChunkOffset != valueCurrentLength;

					if (valueOutOfSync) {
						break;
					}

					valueChunkLength = Math.min(valueLength - ret.valueChunkOffset, 60);

					System.arraycopy(ret.valueChunkData, 0, value, valueCurrentLength, valueChunkLength);

					valueCurrentLength += valueChunkLength;
				}
			}

			if (valueOutOfSync) { // discard remaining stream to bring it back in-sync
				while (ret.valueChunkOffset + 60 < valueLength) {
					ret = getLEDValuesLowLevel(index, length);
					valueLength = ret.valueLength;
				}

				throw new StreamOutOfSyncException("Value stream is out-of-sync");
			}
		}

		return value;
	}

	/**
	 * Adds a FrameStarted listener.
	 */
	public void addFrameStartedListener(FrameStartedListener listener) {
		listenerFrameStarted.add(listener);
	}

	/**
	 * Removes a FrameStarted listener.
	 */
	public void removeFrameStartedListener(FrameStartedListener listener) {
		listenerFrameStarted.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletLEDStripV2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletLEDStripV2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLEDStripV2Config cfg = (BrickletLEDStripV2Config) config.as(BrickletLEDStripV2Config.class);
        this.addFrameStartedListener((length) -> {if(true) {triggerChannelFn.accept("LEDStripV2FrameStarted", transformLEDStripV2FrameStartedCallback0(length, cfg));}});
        this.setChipType(cfg.chipType);
		    this.setChannelMapping(cfg.channelMapping);
		    this.setFrameDuration(cfg.frameDuration);
		    this.setClockFrequency(cfg.clockFrequency.longValue());
		{
		this.setFrameStartedCallbackConfiguration(true);
		}
		{
		BrickletLEDStripV2LEDValuesConfig channelCfg = getChannelConfigFn.apply("LEDStripV2LEDValues").as(BrickletLEDStripV2LEDValuesConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletLEDStripV2Config cfg = (BrickletLEDStripV2Config) config.as(BrickletLEDStripV2Config.class);
        this.listenerFrameStarted.clear();
        this.setFrameStartedCallbackConfiguration(false);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletLEDStripV2Config cfg = (BrickletLEDStripV2Config) config.as(BrickletLEDStripV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("LEDStripV2FrameStarted");
		result.add("LEDStripV2LEDValues");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "LEDStripV2LEDValues":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "LEDStripV2LEDValues"), "LED Values", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:LEDStripV2LEDValues")).withDescription("The RGB(W) values for the LEDs.<br/><br/>Command format is a ','-separated list of integers. The first integer is the index of the first LED to set, additional integers are the values to set. Values are between 0 (off) and 255 (on). If the channel mapping has 3 colors, you need to give the data in the sequence R,G,B,R,G,B,R,G,B,... if the channel mapping has 4 colors you need to give data in the sequence R,G,B,W,R,G,B,W,R,G,B,W...<br/><br/>The data is double buffered and the colors will be transfered to the LEDs when the next frame duration ends. You can set at most 2048 RGB values or 1536 RGBW values.<br/><br/> For example sending 2,255,0,0,0,255,0,0,0,255 will set the LED 2 to red, LED 3 to green and LED 4 to blue.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge LED Strip Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Controls up to 2048 RGB(W) LEDs").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("LEDStripV2FrameStarted", new ChannelTypeUID("system", "trigger")).withLabel("Frame Started").build(), new ChannelDefinitionBuilder("LEDStripV2LEDValues", new ChannelTypeUID("tinkerforge", "LEDStripV2LEDValues")).build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:ledstripv2":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("chipType", Type.INTEGER).withDefault("2801").withDescription("The type of the LED driver chip. We currently support the chips<br/><br/><ul><li>WS2801</li><li>WS2811</li><li>WS2812 / SK6812 / NeoPixel RGB</li><li>SK6812RGBW / NeoPixel RGBW (Chip Type = WS2812)</li><li>LPD8806</li><li>APA102 / DotStar</li></ul>").withLabel("LED Driver Chip Type").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("2801", "WS2801"), new ParameterOption("2811", "WS2811"), new ParameterOption("2812", "WS2812"), new ParameterOption("8806", "LPD8806"), new ParameterOption("102", "APA102"))).build(), ConfigDescriptionParameterBuilder.create("channelMapping", Type.INTEGER).withDefault("36").withDescription("The channel mapping for the connected LEDs.<br><br>If the mapping has 4 colors, the LED Values channel expects 4 values per pixel and if the mapping has 3 colors it expects 3 values per pixel.<br/><br/>The LED Values channel always expects the order RGB(W). The connected LED driver chips might have their 3 or 4 channels in a different order. For example, the WS2801 chips typically use BGR order, then WS2812 chips typically use GRB order and the APA102 chips typically use WBGR order.<br/><br/>The APA102 chips are special. They have three 8-bit channels for RGB and an additional 5-bit channel for the overall brightness of the RGB LED making them 4-channel chips. Internally the brightness channel is the first channel, therefore one of the Wxyz channel mappings should be used. Then the W channel controls the brightness.").withLabel("LED Channel Mapping").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("6", "RGB"), new ParameterOption("9", "RBG"), new ParameterOption("33", "BRG"), new ParameterOption("36", "BGR"), new ParameterOption("18", "GRB"), new ParameterOption("24", "GBR"), new ParameterOption("27", "RGBW"), new ParameterOption("30", "RGWB"), new ParameterOption("39", "RBGW"), new ParameterOption("45", "RBWG"), new ParameterOption("54", "RWGB"), new ParameterOption("57", "RWBG"), new ParameterOption("78", "GRWB"), new ParameterOption("75", "GRBW"), new ParameterOption("108", "GBWR"), new ParameterOption("99", "GBRW"), new ParameterOption("120", "GWBR"), new ParameterOption("114", "GWRB"), new ParameterOption("135", "BRGW"), new ParameterOption("141", "BRWG"), new ParameterOption("147", "BGRW"), new ParameterOption("156", "BGWR"), new ParameterOption("177", "BWRG"), new ParameterOption("180", "BWGR"), new ParameterOption("201", "WRBG"), new ParameterOption("198", "WRGB"), new ParameterOption("216", "WGBR"), new ParameterOption("210", "WGRB"), new ParameterOption("228", "WBGR"), new ParameterOption("225", "WBRG"))).build(), ConfigDescriptionParameterBuilder.create("frameDuration", Type.INTEGER).withDefault("100").withDescription("The frame duration in milliseconds. This configures how fast the Frame Started Channel will trigger.").withLabel("Frame Duration").build(), ConfigDescriptionParameterBuilder.create("clockFrequency", Type.INTEGER).withDefault("1660000").withDescription("The frequency of the clock in Hz. The Bricklet will choose the nearest achievable frequency, which may be off by a few Hz.<br/><br/>If you have problems with flickering LEDs, they may be bits flipping. You can fix this by either making the connection between the LEDs and the Bricklet shorter or by reducing the frequency.<br/><br/>With a decreasing frequency your maximum frames per second will decrease too.<br/><br/>The default value is 1.66MHz (1660000Hz).").withLabel("Clock Frequency").withMinimum(BigDecimal.valueOf(10000)).withMaximum(BigDecimal.valueOf(2000000)).build()), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:LEDStripV2LEDValues":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLEDStripV2Config cfg = (BrickletLEDStripV2Config) config.as(BrickletLEDStripV2Config.class);
        switch(value) {
            case "LEDStripV2FrameStarted":
               return;
            case "LEDStripV2LEDValues":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletLEDStripV2Config cfg = (BrickletLEDStripV2Config) config.as(BrickletLEDStripV2Config.class);
        switch(channel) {
            case "LEDStripV2LEDValues":
                if (command instanceof StringType) {
                    BrickletLEDStripV2LEDValuesConfig channelCfg = channelConfig.as(BrickletLEDStripV2LEDValuesConfig.class);
                    StringType cmd = (StringType) command;
                    this.setLEDValues(Helper.parseLEDValueIndex(cmd.toString(), logger), Helper.parseLEDValues(cmd.toString(), logger));
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformLEDStripV2FrameStartedCallback0(int length, BrickletLEDStripV2Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
}
